#ifndef COMMUNICATION_H_INCLUDED
#define COMMUNICATION_H_INCLUDED

#include <pthread.h>
#include <iostream>
#include <string>
#include <string.h>

#include "RobotModel.h"
#include "communication_structs.h"
#include "messageQueue.h"
#include "posix_messages.h"
#include "main.h"

extern bool waypoints_received;
extern bool start_received;
extern pthread_mutex_t startMutex;

void communicationInit();
void communicationExit();
extern "C" void * communicationReceiveThread(void * arg);

void resetOdometry();

void getMotorSpeed(motor_speed_t &ms);
void setMotorSpeed(motor_speed_t &ms);

void getStartingPosition(starting_position *s);
void setStartingPosition(starting_position *s);

void getWpList(waypoint_list *list);
void setWpList(waypoint_list *list);

void sendPID(motor_pid_t *pid);
void sendMotorSpeed(motor_speed_ref_t *motorspeed);

void sendRobotPositionAi(robot_position *robotposition);
void sendRobotPositionCvsys(odometry_t odo, robot_position *robotposition, robot_state robot);
void sendOpponentPositionAi(opponent_position *opponentposition);
void sendOpponentPositionCvsys(opponent_position *opponentposition);
void sendWaypointReached();

#endif // COMMUNICATION_H_INCLUDED
