#include <iostream>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstdarg>
#include <sys/time.h>
#include "logger.h"

Logger::Logger(){

}

Logger::~Logger(){
    fclose(logFile);
}

int Logger::startLog(std::string logname){
    char filetime[20];
	char filename[100];
	time_t t;
    struct tm *tmp;
    t = time(NULL);
    tmp = localtime(&t);
	logTime = getTime();
	strftime(filetime, 20, "%Y.%m.%d-%H.%M.%S", tmp);
	sprintf(filename, "%s %s.txt", logname.c_str(), filetime);
	if ((logFile = fopen(filename, "w")) == NULL) {
		perror("fopen");
        return -1;
	}
    return 0;
}

void Logger::stopLog(){
    fclose(logFile);
}

void Logger::logEvent(int eventID, int count, ...){

    double timeStamp = getTime()-logTime;

    va_list ap;
	va_start(ap, count);

    fprintf(logFile, "%d\t%f\t", eventID, timeStamp);

    //read arguments
    for(int i=0;i<count;i++){
        int val=va_arg(ap,int);
        fprintf(logFile, "%d\t", val);
    }

    fprintf(logFile,"\n");

    va_end(ap);
}

void Logger::logEventFloat(int eventID, int count, ...){

    double timeStamp = getTime()-logTime;

    va_list ap;
	va_start(ap, count);

    fprintf(logFile, "%d\t%f\t", eventID, timeStamp);

    //read arguments
    for(int i=0;i<count;i++){
        double val=va_arg(ap,double);
        fprintf(logFile, "%f\t", val);
    }

    fprintf(logFile,"\n");

    va_end(ap);
}

double Logger::getTime(){

    static timeval tp;
    gettimeofday(&tp,NULL);
    return static_cast<double>(tp.tv_sec) + static_cast<double>(tp.tv_usec)/1000000.0;
}
