#ifndef __NAVSYS_STRUCTS_H__
#define __NAVSYS_STRUCTS_H__

typedef struct{
	double x_local;     // robot position
	double y_local;
	double theta_local;
	double u_body;      // robot velocity
	double w_body;      // angular velocity
}robot_state;

typedef struct{
    double r_body;      //  distance robot has traveled since previous measurement
    double psi_body;    //  angle robot has traveled since previous measurement
    double odo_left;    //  distance odometry wheels has traveled since previous measurement
    double odo_right;   //  ---
}delta;

typedef struct{
    short x_local;              //  mm
	short y_local;
	double theta_local;         // rad: 0-2*PI (x-axis: 0, y-axis: pi/2)
	bool should_correct_angle;  // true if angle on waypoint is important.
	bool top_of_hill;
	int circle;    /* if the robot is to drive in a circle. Is to be sent on the second waypoint.
                      -1 if left, 1 if right. The radius of the circle is constant */
	bool stop_on_wp;            // to make the robot stand still until further information given;
	bool reverse;               // Robot drives in reverse to position.
    double r_body;              // distance to next waypoint
	double psi_body;            // angle to next waypoint
	double theta_body;          // desired heading at next waypoint
}waypoint;

typedef struct{
    double u_body;
    double w_body;
}output_speed;

#endif
