#define PMQ_NAVSYS  "/navsys"
#define PMQ_CVSYS   "/cvsys"
#define PMQ_AI      "/ai"
#define PMQ_GATEWAY "/gateway"
#define PMQ_LOGSYS  "/logsys"

#define GATEWAY_ID  1
#define NAVSYS_ID   2
#define CVSYS_ID    3
#define AI_ID       4

#define PM_SYSTEMCHECK                  1 //TO ALL


/**
 * To Gateway(Sensor,Motor Control, EiT,Power Panel)
 */
#define PM_GATEWAY_CAN_MESSAGE          100
#define PM_GATEWAY_GAME_STOP			101

#define PM_SWITCH_PANEL_BLUE_LED 		102
#define PM_SWITCH_PANEL_YELLOW_LED		103
#define PM_SWITCH_PANEL_RESET_LED		104

#define PM_MOTOR_PID                    110
#define PM_MOTOR_SPEED_REF              111

#define PM_SENSOR_STATUS                120
#define PM_SENSOR_SYSTEMCHECK           121
#define PM_SENSOR_CONFIG                122
#define PM_SENSOR_ODOMETRY_RESET        123

#define PM_SENSOR_TEMPERATURE           124
#define PM_SENSOR_VOLTAGE               125

#define PM_SENSOR_ANALOG                126
#define PM_SENSOR_DIGITAL_IN            127
#define PM_SENSOR_DIGITAL_OUT           128
#define PM_SENSOR_DIP_SWITCH            129

#define PM_EIT_START					150
#define PM_EIT_DELIVER 					151
#define PM_EIT_PICK_TOMATO				152
#define PM_EIT_PREPARE_FOR_ORANGE 		153
#define PM_EIT_PICK_ORANGE 				154
#define PM_EIT_STOP						155


/**
 * To Navsys
 */
#define PM_NAVSYS_MOTOR_STATUS          200
#define PM_NAVSYS_MOTOR_ERROR           201
#define PM_NAVSYS_MOTOR_SPEED           202
#define PM_NAVSYS_MOTOR_CURRENT         203

#define PM_NAVSYS_SENSOR_STATUS         210
#define PM_NAVSYS_ODOMETRY              211
#define PM_NAVSYS_ODOMETRY_SPEED        212
#define PM_NAVSYS_ACCELEROMETER         213
#define PM_NAVSYS_RATE_GYRO             214
#define PM_NAVSYS_TEMPERATURE           215
#define PM_NAVSYS_VOLTAGE               216

#define PM_NAVSYS_ANALOG                217
#define PM_NAVSYS_DIGITAL_IN            218

#define PM_NAVSYS_OPPONENT              219

#define PM_NAVSYS_STARTING_POSITION     230
#define PM_NAVSYS_UPDATE_WP             231
#define PM_NAVSYS_STOP                  232


/**
 * To CVsys
 */
#define PM_CVSYS_GET_CYLINDER_CONFIG    300

#define PM_CVSYS_ROBOT_POSITION         310
#define PM_CVSYS_OPPONENT_POSITION      311


/**
 * To AI
 */
#define PM_AI_CYLINDER_CONFIG           400
#define PM_AI_BALL_POSITIONS            401
#define PM_AI_CVSYS_SYSTEMCHECK         402

#define PM_AI_ROBOT_POSITION            410
#define PM_AI_OPPONENT_POSITION         411
#define PM_AI_WP_REACHED                412

#define PM_AI_START_GAME				420
#define PM_AI_RESET_ROBOT				421
#define PM_AI_BLUE_TEAM_COLOR			422
#define PM_AI_YELLOW_TEAM_COLOR			423

#define PM_AI_TOMATO_PICKED				450
#define PM_AI_CORN_PICKED				451
#define PM_AI_ORANGE_PICKED				452
#define PM_AI_BLOCKING_CORN				453
#define PM_AI_DELIVERY_DONE				454


/**
 *  Posix Message Priorities
 */
#define PRIORITY_HIGHEST 	31	// Max pri. compliant with POSIX.1-2001
#define PRIORITY_VERY_HIGH 	25
#define PRIORITY_HIGH 		20
#define PRIORITY_NORMAL 	15
#define PRIORITY_LOW 		10
#define PRIORITY_VERY_LOW 	5
#define PRIORITY_LOWEST 	0
